<?xml version="1.0" encoding="UTF-8"?>
<!-- /**
*  Copyright 2007-2015 Hewlett-Packard Development Company, L.P.
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
 -->
<schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
	targetNamespace="http://www.coco-cloud.eu/dsa"
	elementFormDefault="qualified"
xmlns="http://www.w3.org/2001/XMLSchema"
xmlns:coco-cloud="http://www.coco-cloud.eu/dsa" >

	   <element name="dsa" type="coco-cloud:dsaType"/>
	   <complexType name="dsaType">
	   	 <sequence>
	   	    <element name="description" type="string" minOccurs="0" maxOccurs="1"/>
	   	    <element name="expirationPolicy" type="coco-cloud:complexPolicyType" minOccurs="0" maxOccurs="1"/>
	   	    <element name="revocationPolicy" type="coco-cloud:complexPolicyType" minOccurs="0" maxOccurs="1"/>
	   	    <element name="updatePolicy" type="coco-cloud:complexPolicyType" minOccurs="0" maxOccurs="1"/>
    	   	<element name="parties" type="coco-cloud:partiesType" minOccurs="1" maxOccurs="1"/>
        	<element name="validity" type="coco-cloud:validityType" minOccurs="1" maxOccurs="1"/>
        	<element name="data" type="coco-cloud:dataType" minOccurs="0" maxOccurs="1"/>
	   		<element name="authorizations" type="coco-cloud:authorizationsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="dataSubjectAuthorizations" type="coco-cloud:authorizationsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="obligations" type="coco-cloud:obligationsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="prohibitions" type="coco-cloud:prohibitionsType"
	   				minOccurs="0" maxOccurs="1"/>
	    	<element name="derivedObjectsAuthorizations" type="coco-cloud:authorizationsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="derivedObjectsObligations" type="coco-cloud:obligationsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="derivedObjectsProhibitions" type="coco-cloud:prohibitionsType"
	   				minOccurs="0" maxOccurs="1"/>
	   		<element name="dataClassification" type="string"
	   				maxOccurs="1" minOccurs="0"/>
	   		<element name="consentRequired" type="boolean" minOccurs="0" maxOccurs="1"/>
	   	 	</sequence>
	   		<attribute name="title" type="string"
	   				use="required"/>
	   		<attribute name="id" type="string"
	   				use="required"/>
		   	<!-- a reference to the DSA from which the current DSA follows. If empty the dsa is a template-->
	    	<attribute name="templateId" type="string"/>
		   	<attribute name="status" type="coco-cloud:statusType" use="required"/>
		    <attribute name="purpose" type="string"	use="optional"/>
		    <attribute name="application-domain" type="string"	use="optional"/>
		   	<attribute name="version" type="string" use="required"/>
		   	<attribute name="vocabulary-url" type="anyURI" use="optional"/>
		   	<attribute name="vocabulary-path" type="string"  use="optional"/>
		   	<attribute name="governing-law" type="string" use="optional" />
		   	<attribute name="indemnities" type="string" use="optional"/>
		   	<attribute name="encryption-key-schema" type="string" use="required" />
		   	<attribute name="user-consent" type="boolean" use="optional"/>
      	</complexType>

	<complexType name="partiesType">
		<sequence>
			<element name="organization" type="coco-cloud:entityType" maxOccurs="unbounded" minOccurs="1"/>
		</sequence>
	</complexType>

	<complexType name="entityType">
		<attribute name="id" type="ID"/>
		<attribute name="name" type="xs:string"/>
		<attribute name="role" type="coco-cloud:role" use="optional"/>
		<attribute name="responsibilities" type="xs:string" use="optional"/>
	</complexType>

	<simpleType name="role">
		<restriction base="xs:string">
			<enumeration value="data-controller"/>
			<enumeration value="data-processor"/>
			<enumeration value="data-subject"/>
		</restriction>
	</simpleType>

	<complexType name="validityType">
	   		<sequence>
	   			<element name="startDate" type="date" maxOccurs="1"
	   				minOccurs="1"/>

	   			<element name="endDate" type="date" maxOccurs="1"
	   				minOccurs="1"/>

	   			<!-- the "offlineLicencesDuration" xs:attribute is a duration; for
    		the sake of simplicity we will express it as number of days -->
	   			<element name="offlineLicencesDuration" type="duration" maxOccurs="1" minOccurs="1"/>
	   		</sequence>
	   	</complexType>


	<complexType name="authorizationsType">
		<sequence>
			<element name="authorization"
				type="coco-cloud:authorizationType" maxOccurs="unbounded"
				minOccurs="1"/>
		</sequence>
	</complexType>

	<complexType name= "expressionType">
		<simpleContent>
			<extension base="xs:string">
				<attribute name="language" type="coco-cloud:languageType"/>
				<attribute name="issuer" type="coco-cloud:issuerType"/>
			</extension>
		</simpleContent>
	</complexType>
	<complexType name="expressionseqType" abstract="true">
		<sequence>
			<element name="expression" type="coco-cloud:expressionType" maxOccurs="unbounded" minOccurs="1"/>
		</sequence>
	</complexType>

	<simpleType name="languageType">
		<restriction base="xs:string">
			<enumeration value="CNL4DSA"/>
			<enumeration value="CNL_4_DSA_E"/>
			<enumeration value="UPOL"/>
			<enumeration value="UserText"/>
		</restriction>
	</simpleType>

	<simpleType name="issuerType">
		<restriction base="xs:string">
			<enumeration value="Legal Expert"/>
			<enumeration value="Policy Expert"/>
			<enumeration value="User"/>
		</restriction>
	</simpleType>

	<complexType name="statementType" abstract="true">
		<complexContent>
			<extension base="coco-cloud:expressionseqType">
				<attribute name="id" type="ID" use="required"></attribute>
				<attribute name="index" type="int" use="required"></attribute>
				<attribute name="isProtected" type="boolean" use="optional"></attribute>
				<attribute name="isPendingRule" type="boolean" use="optional"></attribute>
				<attribute name="statementInfo" type="string" use="optional"></attribute>
				<attribute name="inputValue" type="string" use="optional"></attribute>
				<attribute name="conflict" type="boolean" use="optional"></attribute>
			</extension>
		</complexContent>
	</complexType>
	<complexType name="obligationType">
		<complexContent>
			<extension base="coco-cloud:statementType">
				<attribute name="category" type="coco-cloud:obligations_category" use="optional"/>
			</extension>
		</complexContent>
	</complexType>

	<complexType name="prohibitionType">
		<complexContent>
			<extension base="coco-cloud:statementType">
				<attribute name="category" type="coco-cloud:authorisations_category" use="optional"/>
			</extension>
		</complexContent>
	</complexType>


	<simpleType name="obligations_category">
		<restriction base="xs:string">
			<enumeration value="Privacy"/>
			<enumeration value="Confidential"/>
			<enumeration value="Audit"/>
			<enumeration value="Warranties"/>
			<enumeration value="Termination"/>
			<enumeration value="TransferOfData"/>
			<enumeration value="Other"/>
		</restriction>
	</simpleType>

	<simpleType name="authorisations_category">
		<restriction base="xs:string">
			<enumeration value="DataSubject"/>
			<enumeration value="Other"/>
		</restriction>
	</simpleType>

	<complexType name="authorizationType">
		<complexContent>
			<extension base="coco-cloud:statementType">
				<attribute name="category" type="coco-cloud:authorisations_category" use="optional"/>
			</extension>
		</complexContent>
	</complexType>


	<simpleType name="statusType">
		<restriction base="xs:string">
			<enumeration value="TEMPLATE"/>
			<enumeration value="CUSTOMISED"/>
			<enumeration value="PREPARED"/>
			<enumeration value="COMPLETED"/>
			<enumeration value="AVAILABLE"/>
		</restriction>
	</simpleType>

   <simpleType name="policyType">
        <restriction base="xs:string">
            <enumeration value="DenyAll"/>
            <enumeration value="DenyAllAndDeleteNow"/>
            <enumeration value="DeleteInSpecifiedPeriod"/>
        </restriction>
    </simpleType>

	<complexType name="authorisationsType">
		<sequence>
			<element name="authorisation" type="coco-cloud:authorisationsType" maxOccurs="unbounded" minOccurs="1"/>
		</sequence>
	</complexType>

	<complexType name="complexPolicyType">
        <sequence>
            <element name="complexPolicy" type="coco-cloud:policyType" maxOccurs="1" minOccurs="1"/>
        </sequence>
        <attribute name="periodInDays" type="int" use="optional"/>
    </complexType>

	<complexType name="obligationsType">
		<sequence>
			<element name="obligation" type="coco-cloud:obligationType"
				maxOccurs="unbounded" minOccurs="1"/>

		</sequence>
	</complexType>

	<complexType name="prohibitionsType">
		<sequence>
			<element name="prohibition" type="coco-cloud:prohibitionType"
				maxOccurs="unbounded" minOccurs="1"/>

		</sequence>
	</complexType>

	 <complexType name="dataType">
    	<sequence>
    		<element name="datum"
    			type="coco-cloud:datumType" maxOccurs="unbounded"
    			minOccurs="1">
    		</element>
    	</sequence>
    </complexType>

    <complexType name="datumType">
    	<complexContent>
    		<extension base="coco-cloud:expressionseqType">
    			<attribute name="id" type="ID" use="required"></attribute>
    			<attribute name="value" type="string" use="optional"></attribute>
    		</extension>
    	</complexContent>
    </complexType>


</schema>